/*    Copyright (C) 1999,  Daniel Schulz	   
 * 
 *    This file is part of the TDI library. The TDI library implements  
 *    the generic part of the Thread Debug Interface for POSIX Threads
 *    Implementations - TDI.
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Library General Public
 *    License as published by the Free Software Foundation; either
 *    version 2 of the License, or (at your option) any later version.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Library General Public License for more details.
 *
 *    You should have received a copy of the GNU Library General Public
 *    License along with this library; if not, write to the Free
 *    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *    Report problems and direct all questions to:
 *
 *    tdi-bugs@informatik.hu-berlin.de
 *	
 * $Author: dschulz $ $Date: 1999/05/03 23:04:08 $ $Name: TDI-alpha-release-2 $ File: smalloc.h
 *
 */
#ifndef _smalloc_h_
#define _smalloc_h_
/* the uninterruptable memory management */
#include <stdlib.h>

/* FIXME: the complete malloc stuff has to be aligned, *
 *        so it works only on LINUX                    */

#if defined(__linux__) || (defined(__sun__) && !defined(_svr4__))
/* use this to dis/enable the s_-mem *
 * support                           */
#define free s_free 
#define malloc s_malloc
#define calloc s_calloc
#define realloc s_realloc
#define strdup s_strdup  
#endif

/* whole size */
#define SMEM_SIZE 500000
/* number of entries */
#define SMEM_ENTRYNR  10000

void  s_free(void *ptr);
void* s_malloc(size_t size);
void* s_calloc(size_t nmemb, size_t size);
char *s_strdup(const char *s); 
void *s_realloc(void *ptr, size_t size);
#endif














