/*    Copyright (C) 1999,  Daniel Schulz	   
 * 
 *    This file is part of the TDI library. The TDI library implements  
 *    the generic part of the Thread Debug Interface for POSIX Threads
 *    Implementations - TDI.
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Library General Public
 *    License as published by the Free Software Foundation; either
 *    version 2 of the License, or (at your option) any later version.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Library General Public License for more details.
 *
 *    You should have received a copy of the GNU Library General Public
 *    License along with this library; if not, write to the Free
 *    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *    Report problems and direct all questions to:
 *
 *    tdi-bugs@informatik.hu-berlin.de
 *	
 * $Author: dschulz $ $Date: 1999/05/03 23:04:08 $ $Name: TDI-alpha-release-2 $ File: tdi-access.h
 *
 */
#ifndef _tdi_access_h_
#define _tdi_access_h_

#include "tdi-access-defs.h"

/* TdiAccessPreCompile implements a first pass through the request string *
 * - information like visible attributes and computed keywors can be      *
 *   be extracted to get the access functions                             */

int 
TdiAccessPreCompile( /* in */ 
		    char*                     Request , 
		    /* out */ 
		    RelTypeT*                 EntityTypePtr , 
		    char**                    PreCompString, 
		    TdiAccessListT**          VisibleList,
		    TdiAccessListT**          ComputedList,
		    TdiOptimizationListT**    OptiList);

/* TdiAccesssRTEvaluation computes the boolean expression over the *
 * entities attributes -> functions for access are used according  *
 * to the precompile information                                   *
 * communaication PreCompile -> TRTEval is realized by transforming*
 * the access string                                               */

int 
TdiAccessRTEvaluation(char*                     PreCompResult, 
		      RelTypeT                  RelType, 
		      void*                     EntityPtr);


/* all in one solution */

int
TdiAccessRequestHandler(char*                     request, 
			char**                    response);

/* returns the index of that symbol, if it is known */
int
TdiAccessAddSymbol(RelTypeT RelType, 
		   char* Name, 
		   AttrDomainT *ValuePtr,
		   TdiAccessListT* AccessList);

#endif















